<?php
// -------------------------------------------------------------------------------------
// jGallery installation
// -------------------------------------------------------------------------------------
define ('VERSION','2-RC2');



// -------------------------------------------------------------------------------------
// function gets languages and version info from www.jgallery.nl
// -------------------------------------------------------------------------------------
function jgall_get_remote_languages()
{
   global $defaultlang , $defaultscriptlang ;
   error_reporting(E_NOTICE);
   $_SESSION['latest_release'] = VERSION ;
   $_SESSION['lang_setup_available'] = array();
   $_SESSION['lang_available'] = array();
   $fileserv = 'http://www.jgallery.nl/files/'; // '../test_fileserver/' ; // 
   if( $latest_release = file_get_contents( $fileserv . 'VERSION-info.txt' ) )
   {
      $_SESSION['latest_release'] = ( trim($latest_release) == VERSION ) ? VERSION : trim($latest_release) ;
   }
   if( $list_setup_language = file_get_contents( $fileserv . 'list_setup_language.php' ) )
   {
      $_SESSION['lang_setup_available'] = explode( ',' , $list_setup_language ) ;
   }
   if( $list_language = file_get_contents( $fileserv . 'list_language.php' ) )
   {
      $_SESSION['lang_available'] = explode( ',' , $list_language ) ;
   }
   $lang_setup_available = array();
   $lang_setup_available[] = $defaultlang;
   if ( ( !empty( $_SESSION['lang_setup_available'] ) ) && ( function_exists( 'simplexml_load_string' ) ) )
   {
      foreach ( $_SESSION['lang_setup_available'] as $langfile )
      {
         $explode = explode( '_' , str_replace( '.xml' , '' , $langfile ) );
         if( ( trim( $explode[4] ) == VERSION ) && ( $xml = file_get_contents( trim( $fileserv . 'setup/' . $langfile ) ) ) )
         {
            $lang_data = ( array ) simplexml_load_string($xml);
            $lang_setup_available[] = $lang_data;
         }
      }
   }
   $_SESSION['lang_setup_available'] = $lang_setup_available ;
   $lang_available = array();
   $lang_available[] = $defaultscriptlang;
   if ( ( !empty( $_SESSION['lang_available'] ) ) && ( function_exists( 'simplexml_load_string' ) ) )
   {
      foreach ( $_SESSION['lang_available'] as $langfile )
      {
         $explode = explode( '_' , str_replace( '.xml' , '' , $langfile ) );
         if( ( trim( $explode[3] ) == VERSION ) && ( $xml = file_get_contents( trim( $fileserv . 'jgallery/' . $langfile ) ) ) )
         {
            $lang_data = ( array ) simplexml_load_string($xml);
            $lang_available[] = $lang_data;
         }
      }
   }
   $_SESSION['lang_available'] = $lang_available ;
   error_reporting(E_ALL);
} // --> END function


// -------------------------------------------------------------------------------------
// function replaces variables in language
// -------------------------------------------------------------------------------------
function jgall_parse_language($string)
{
   $regs = array(
    'VERSION' => VERSION ,
    'NEW_VERSION' => 'jGallery' . $_SESSION['latest_release'] ,
    'DOCPAGE' => '<a href="http://www.jgallery.nl/?t=8" target="_blank">http://www.jgallery.nl/?t=8</a>' ,
    'NL' => '<br />' ,
    'B' => '<b>' ,
    '/B' => '</b>' ,
    'I' => '<I>' ,
    '/I' => '</I>' ,
   );
   foreach($regs as $key => $value)
   {
      $string = preg_replace( '|({'.$key.'})|' , $value , $string );
   }
   return $string ;
} // --> END function


// -------------------------------------------------------------------------------------
// function builds the output
// -------------------------------------------------------------------------------------
function jgall_build_page ($title='Title',$header='Header',$content='Content',$vardump='')
{
   if( !file_exists('./template/admin.tpl') )
   {
      die (' Missing file "./template/admin.tpl"! Setup can not start. ');
   }
   else
   {
      $raw_tpl = file_get_contents('./template/admin.tpl') ;
      $regs = array(
       'VERSION' => VERSION,
       'TITLE' => $title,
       'HEADER' => $header,
       'CONTENT' => $content,
       'UPDATE' => $_SESSION['check_update'],
      );
      foreach($regs as $key => $value)
      {
         $raw_tpl = preg_replace( '|({'.$key.'})|' , $value , $raw_tpl );
      }
      // Development option
      if( !empty($vardump) )
      {
         echo '<code><pre>';
         print_r($vardump);
         echo '</pre></code><hr /><br /><br />' ;
      }
      echo $raw_tpl ;
   }
   die();
} // --> END function


// -------------------------------------------------------------------------------------
// Function to check weither a dir can be writen
// -------------------------------------------------------------------------------------
function jgall_is_writable($path)
{
//will work in despite of Windows ACLs bug
//NOTE: use a trailing slash for folders!!!
//see http://bugs.php.net/bug.php?id=27609
//see http://bugs.php.net/bug.php?id=30931

    if ($path{strlen($path)-1}=='/') // recursively return a temporary file path
        return JGALL_is_writable($path.uniqid(mt_rand()).'.tmp');
    else if (is_dir($path))
        return JGALL_is_writable($path.'/'.uniqid(mt_rand()).'.tmp');
    // check tmp file for read/write capabilities
    $rm = file_exists($path);
    $f = @fopen($path, 'a');
    if ($f===false)
        return false;
    fclose($f);
    if (!$rm)
        unlink($path);
    return true;
} // --> END function


// -------------------------------------------------------------------------------------
// function writes array values to file in php syntax
// -------------------------------------------------------------------------------------
function jgall_array2file($save, $file, $name='data', $level='0') 
{
   $succes = false;
   if($level > '0')
   {
      $sp = '';
      $temp = '';
      for($i='0'; $i < $level; $i++)
      {
         $sp .= "\t";
      }
      foreach($save as $key => $val)
      {    
         if(is_array($val))
         {  
            $temp .= $sp . '\'' . $key . '\' => array(' . "\r\n" . 
                     jgall_array2file($val,0,0,$level+1) . $sp . '),' . "\r\n"; 
         }    
         else
         { 
            $temp .= $sp . '\'' . $key . '\' => \'' . htmlspecialchars($val) . '\',' . "\r\n";    
         }    
      } return($temp);   
   }   
   else
   { 
      $content = '<?php'."\r\n" . '// saved: '.date("y m d, h:i")."\r\n" . '$' . $name . ' = ' . "\r\n" . 'array(' . "\r\n" . jgall_array2file($save,0,0,1).');' . "\r\n" . '?'.'>';   
      if(fwrite(fopen($file,"w+"),$content))
      {    
          $succes = true;
      }   
   } return($succes);   
} // --> end function



// -------------------------------------------------------------------------------------
// Set defaults
// -------------------------------------------------------------------------------------
$defaultlang = array(
	'LANG_TITLE' => 'ENGLISH (DEFAULT)',
	'welcome_to' => 'Welcome to',
	'installation' => 'installation wizzard',
	'newer_version' => '{NEW_VERSION} is available!',
	'choose_language' => 'Select language',
	'choose_language_install_explain' => 'Choose the language in wich the installation wizzard will run.',
	'submit' => 'Submit',
	'create_folders' => 'Create folders',
	'error' => 'Fatal error',
	'cannot_write_explain' => 'Not possible to create directorys on the server. Setup can not continue... {NL}{NL}Refer to documentation: {DOCPAGE}',
	'build_cache_failded' => 'Error building the cache. Setup can not continue... {NL}{NL}Refer to documentation: {DOCPAGE}',
	'create_cache_explain' => 'Setup created a directory "cache/" on the server and saved default settings to it.',
	'settings' => 'Change settings',
	'settings_explain' => 'Change the settings below to complete the installation',
	'login_details' => 'Login details',
	'login_details_explain' => 'Choose login details to administer jGallery. It is important that you remember these for future use (write them down)!',
	'username' => 'Username',
	'password' => 'Password',
	'password_confirm' => 'Confirm password',
	'install_language' => 'Install-language',
	'install_language_explain' => 'Choose the language in which jGallery will be publicly viewable',
	'finisch_installation' => 'Finisch installation',
	'password_no_match' => 'The passwords you entered did not match',
	'no_username' => 'You did not enter a username',
	'install_complete' => 'Installation complete!',
	'install_complete_explain' => '<b>Congratulations!</b><br /><br />jGallery'.VERSION.' is now installed on your website!',
	'click_view_gallery' => 'Click here to visit your gallery',
	'click_manage_gallery' => 'Click here to manage your albums',
	'customize_explain' => 'Learn how to customize jGallery2 to your preferences',
	'click_read_documentation' => 'Click here to read the documentation',
	'regards' => 'Kind regards,<br /><br /><i>jgallery.nl</i>',
);
$defaultscriptlang = array(
	'LANG_TITLE' => 'ENGLISH (DEFAULT)',
	'title' => 'Powered by jGallery'.VERSION,
	'location' => 'Location',
	'mainfolder' => 'Albums',
	'home' => 'You are in {HOMEDIR}',
	'gohome' => 'Go back to {HOMEDIR}',
	'up' => 'You are in the top directory',
	'goup' => 'Go up one directory',
	'refresh' => 'Refresh this page',
	'downloadimage' => 'Click to download this image',
	'first' => '<< first',
	'prev' => '< previous',
	'image_info' => 'image {B}{CURRENT}{B} of {B}{TOTAL}{B}',
	'next' => 'next >',
	'last' => 'last >>',
	'emptydir' => 'There are no items to be displayed!',
	'gall_detail' => '{B}{FOLDERS}{/B} sub-directory(s) and {B}{IMAGES}{/B} image(s) in "{B}{DIR}{/B}"',
	'folder_info' => '{DIR} :: {FOLDERS} sub-directory(s) and {IMAGES} image(s)',
	'image_detail' => 'Filetype: {MIME} - Original size: {WIDTH} x {HEIGHT} px, {FILESIZE} kB',
	'start_slideshow' => 'Start slideshow',
	'manage_album' => 'Upload pictures and manage albums',
	'visit_us' => 'Visit the jGallery website',
);
$defaultscriptsettings = array(
	'version' => VERSION,
	'template' => 'nautilus',
	'thumbnail_display_mode' => 'OAR',
	'thumbnail_size' => '118',
	'thumbnail_cols' => '4',
	'thumbnail_rows' => '3',
	'filename_length' => '18',
	'view_img_size' => '550',
	'view_slideshow_size' => '550',
	'view_slideshow_timeout' => '5',
	'breadcrumb_devider' => ' / ',
	'pagelink_devider' => ' | ',
	'image_upload_options' => '0',
);



// -------------------------------------------------------------------------------------
// Start
// -------------------------------------------------------------------------------------
session_id( preg_replace( "^(\W|_)^" , '' , VERSION ) );
session_start();
ini_set('default_socket_timeout', 1);



// -------------------------------------------------------------------------------------
// Choose language
// -------------------------------------------------------------------------------------
if( ( ( !isset( $_SESSION['lang'] ) && ( !isset( $_POST['language'] ) ) ) ) OR ( isset( $_GET['lang_change'] ) ) )
{
   jgall_get_remote_languages();
   $_SESSION['check_update'] = ( $_SESSION['latest_release'] == VERSION ) ? '' : ' :: <a href="http://www.jgallery.nl" target="_blank">' . jgall_parse_language($defaultlang['newer_version']) . '' ;
   $page_content = $defaultlang['choose_language_install_explain'] . '<br /><br />' . $defaultlang['choose_language'] . ': <form action="./install.php" method="post"><select name="language">' ;
   $options = array();
   foreach( $_SESSION['lang_setup_available'] as $key => $value )
   {
      $selected = ( $value['LANG_TITLE'] == $defaultlang['LANG_TITLE'] ) ? ' selected' : '' ;
      $options[] = '<option title="' . $value['LANG_TITLE'] . '" value="' . $key . '"' . $selected . '>' . ucfirst( strtolower( $value['LANG_TITLE'] ) ) . '</option>' ;
   }
   sort( $options ) ;
   $page_content .= implode( $options ) . '</select> <input type="submit" value="' . $defaultlang['submit'] . '"></form>' ;
   jgall_build_page ('jGallery' . VERSION . ' ' . $defaultlang['installation'],$defaultlang['choose_language'],$page_content);
}
else
{
   if( isset( $_POST['language'] ) && array_key_exists( intval($_POST['language']) , $_SESSION['lang_setup_available'] ) )
   {
      $_SESSION['lang'] = $_SESSION['lang_setup_available'][intval( $_POST['language'] )] ;
      $_SESSION['page_title'] = 'jGallery' . VERSION . ' ' . $_SESSION['lang']['installation'] . ' (<a href="?lang_change">change language</a>)' ;
   }
}



// -------------------------------------------------------------------------------------
// Check install progress
// -------------------------------------------------------------------------------------
if( file_exists( './cache/status.php' ) )
{
   include( './cache/status.php' );
   $_SESSION['cache']['build'] = ( bool ) $jgall['status']['build'] ;
   $_SESSION['cache']['writable'] = ( bool ) $jgall['status']['writable'] ;
   $_SESSION['cache']['settings'] = $jgall['status']['settings'] ;
}
else
{
   $_SESSION['cache']['build'] = FALSE ;
   if( ( jgall_is_writable( './' ) ) OR ( ( is_dir(  './cache/'  ) ) && ( jgall_is_writable( './cache/' ) ) ) )
   {
      $_SESSION['cache']['writable'] = TRUE ;
   }
   else
   {
      $_SESSION['cache']['writable'] = FALSE ;
      $page_content = jgall_parse_language($_SESSION['lang']['cannot_write_explain']);
      jgall_build_page ($_SESSION['page_title'],'<span style="color:#BC2A4D;">'.$_SESSION['lang']['error'].'</span>',$page_content);
   }
}



// -------------------------------------------------------------------------------------
// Build cache
// -------------------------------------------------------------------------------------
if( !$_SESSION['cache']['build'] )
{
   $_SESSION['cache']['build'] = FALSE ;
   error_reporting(E_NOTICE);
   if( !is_dir(  './cache/'  ) )
   {
      if ( mkdir( './cache/' ) )
      {
         $_SESSION['cache']['writable'] = TRUE ;
      }
   }
   if(
    mkdir('./cache/albums/') &&
    mkdir('./cache/descriptions/') &&
    mkdir('./cache/thumbs/') &&
    mkdir('./cache/thumbs/large/') &&
    jgall_array2file(array('build'=> VERSION , 'writable' => '1', 'settings' => 'defaults'), './cache/status.php', 'jgall[\'status\']') &&
    jgall_array2file(array('username'=> 'install' , 'password' => 'install'), './cache/pwd.php', 'jgall[\'pwd\']') &&
    jgall_array2file($defaultscriptsettings, './cache/settings.php', 'jgall[\'config\']') &&
    jgall_array2file($defaultscriptlang, './cache/language.php', 'jgall[\'lang\']')
   )
   {
      $_SESSION['cache']['build'] = TRUE ;
      $_SESSION['cache']['settings'] = 'defaults' ;
      $_SESSION['logged_in'] = TRUE ;
   }
   else
   {
      $page_content = jgall_parse_language($_SESSION['lang']['build_cache_failded']);
      jgall_build_page ($_SESSION['page_title'],'<span style="color:#BC2A4D;">'.$_SESSION['lang']['error'].'</span>',$page_content);
   }
   error_reporting(E_ALL);
}



// -------------------------------------------------------------------------------------
// Finish
// -------------------------------------------------------------------------------------
if ( $_SESSION['cache']['build'] )
{
   $error_msg_password = '';
   $error_msg_username = '';
   $password = ( !empty($_POST['password']) ) ? htmlspecialchars(strip_tags($_POST['password'])) : '' ;
   $password_confirm = ( !empty($_POST['password_confirm']) ) ? htmlspecialchars(strip_tags($_POST['password_confirm'])) : '' ;
   $username = ( !empty($_POST['username']) ) ? htmlspecialchars(strip_tags($_POST['username'])) : '' ;
   if( ( isset( $_POST['submit'] ) ) && ( $_POST['submit'] == $_SESSION['lang']['finisch_installation'] ) )
   {
      $language = ( array_key_exists( intval($_POST['scriptlanguage']) , $_SESSION['lang_available'] ) ) ? $_SESSION['lang_available'][intval($_POST['scriptlanguage'])] : $defaultscriptlang ; 
      if( ( !empty($_POST['password']) ) && ( !empty($_POST['username']) ) && ( $_POST['password'] == $_POST['password_confirm'] ) )
      {
         jgall_array2file(array('username'=> $_POST['username'] , 'password' => $_POST['password']), './cache/pwd.php', 'jgall[\'pwd\']');
         jgall_array2file(array('build'=> VERSION , 'writable' => '1', 'settings' => 'user'), './cache/status.php', 'jgall[\'status\']');
         jgall_array2file($language, './cache/language.php', 'jgall[\'lang\']');
         $_SESSION['cache']['settings'] = 'user' ;
      }
      if( ( empty($_POST['password']) ) || ( $_POST['password'] != $_POST['password_confirm'] ) )
      {
         $error_msg_password = '<b style="color:#BC2A4D;">' . $_SESSION['lang']['password_no_match'] . '</b><br />' ;
      }
      if( empty($_POST['username']) )
      {
         $error_msg_username = '<b style="color:#BC2A4D;">' . $_SESSION['lang']['no_username'] . '</b><br />' ;
      }
   }
   $page_content = '' ;
   if( $_SESSION['cache']['settings'] == 'defaults' )
   {
      $page_content = $_SESSION['lang']['create_cache_explain'] . '<br />' ;
      $page_content .= '<b>' . $_SESSION['lang']['settings_explain'] . ':</b><br /><br /><br />' ;
      $page_content .= '<form action="install.php" method="post">' ;
      $page_content .= '<div class="header_txt">' . $_SESSION['lang']['install_language'] . ':</div><i>' . $_SESSION['lang']['install_language_explain'] . '</i><br /><br /><select name="scriptlanguage">' ;
      $options = array();
      foreach( $_SESSION['lang_available'] as $key => $value )
      {
         $selected = ( $value['LANG_TITLE'] == $defaultscriptlang['LANG_TITLE'] ) ? ' selected' : '' ;
         $options[] = '<option title="' . $value['LANG_TITLE'] . '" value="' . $key . '"' . $selected . '>' . ucfirst( strtolower( $value['LANG_TITLE'] ) ) . '</option>' ;
      }
      sort( $options ) ;
      $page_content .= implode( $options ) . '</select><br /><br /><br />';
      $page_content .= '<div class="header_txt">' . $_SESSION['lang']['login_details'] . ':</div><i>' . $_SESSION['lang']['login_details_explain'] . '</i><br /><br />' ;
      $page_content .= $error_msg_username . '<b>' . $_SESSION['lang']['username'] . '<br /><input name="username" value="' . $username . '"><br /><br />' . $error_msg_password . $_SESSION['lang']['password'] . '<br /><input type="password" name="password"><br /><br />' . $_SESSION['lang']['password_confirm'] . '</b><br /><input type="password" name="password_confirm"><br /><br /><br />' ;
      $page_content .= '<hr /><input type="submit" name="submit" value="' . $_SESSION['lang']['finisch_installation'] . '"></form>' ;
      jgall_build_page ($_SESSION['page_title'],$_SESSION['lang']['settings'],$page_content);
   }
   else
   {
      $page_content = jgall_parse_language($_SESSION['lang']['install_complete_explain']) . '<br /><br /><br />' ;
      $page_content .= '<a href="./index.php">' . $_SESSION['lang']['click_view_gallery'] . '</a><br />' ;
      $page_content .= '<a href="./ft2.php">' . $_SESSION['lang']['click_manage_gallery'] . '</a><br /><br /><br />' ;
      $page_content .= $_SESSION['lang']['customize_explain'] . ':<br />' ;
      $page_content .= '<a href="http://www.jgallery.nl/?t=6" target="_blank">' . $_SESSION['lang']['click_read_documentation'] . '</a><br /><br /><br />' . jgall_parse_language($_SESSION['lang']['regards']) ;
      session_destroy();
      $title = $_SESSION['lang']['install_complete'] ;
      jgall_build_page($_SESSION['page_title'],$title,$page_content);
   }
}

// --> END
?>
